import Component from '@glimmer/component';

export default class plotYAxis extends Component {
  get axisX() {
    return this.strokeWidth/2;
  }

  get strokeWidth() {
    return this.args.strokeWidth
      ? this.args.strokeWidth
      : '1'
  }

  get stroke() {
    return this.args.stroke
      ? this.args.stroke
      : 'gray'
  }

  get topOffset() {
    return this.args.topOffset
      ? this.args.topOffset
      : '0'
  }

  get tickHeight() {
    return this.args.tickHeight || "1"
  }

  get tickWidth() {
    return this.args.tickWidth || this.strokeWidth * 6
  }

  get tickCount() {
    return this.args.tickCount || 10
  }

  get tickStrokeWidth() {
    return this.args.tickStrokeWidth || this.strokeWidth
  }

  get tickStroke() {
    return this.args.tickStroke || this.stroke
  }

  get ticks() {
    const ticks = [];
    const axisXLeft = this.axisX - this.tickWidth/2;
    const axisXRight = axisXLeft + this.tickWidth;
    const tickSpacing = this.args.height / (this.tickCount + 1)
    for(let i = 1; i <= this.tickCount; i++) {
      ticks.push({
        x1: axisXLeft,
        x2: axisXRight,
        y: tickSpacing * i,
        stroke: this.tickStroke,
        strokeWidh: this.tickHeight
      })
    }
    return  ticks;
  }
}